/*
initbt.c Version 0.2.0  Btree initialize database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

#define MODE 0
#define NODESZ 1
#define RCDLEN 2
#define KEYLEN 3
#define KEYOFST 4
#define DLETOFST 5
#define DLM 6

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Initialize a btree database\n");
   fprintf(stderr,"Usage %s options filename\n", pgm);
   fprintf(stderr,"Options:\n");
   fprintf(stderr,"   -m mode\n");
   fprintf(stderr,"      mode = old for existing file\n");
   fprintf(stderr,"      mode = new for new file\n");
   fprintf(stderr,"      mode = any for old or new file\n");
   fprintf(stderr,"   -n integer for records per node\n");
   fprintf(stderr,"   -r integer for record length\n");
   fprintf(stderr,"   -k integer for key length\n");
   fprintf(stderr,"   -o integer for key offset in record\n");
   fprintf(stderr,"   -d integer for delete byte offset in record\n");
   fprintf(stderr,"Example: %s -m old "
      "-n 15 -r 30 -k 10 -o 5 -d 0 "
      "myfile.bt\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int i;
   int rslt;
   int argrslt;
   int truncflag;
   int nodesz;
   int rcdlen;
   int keylen;
   int keyofst;
   int dletofst;
   char fldlst[32];
   char dbname[256];
   if (argc != 14) putstx(*argv);
   strcpy(fldlst,"zzz");
   i = 1;
   while (i < 13)
      {
      rslt = strcmp(*(argv+i),"-m");
      if (!rslt)
	 {
	 argrslt = strcmp(*(argv+i+1),"old");
	 if (!argrslt)
	    {
	    truncflag = INITOLD;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 argrslt = strcmp(*(argv+i+1),"new");
	 if (!argrslt)
	    {
	    truncflag = INITNEW;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 argrslt = strcmp(*(argv+i+1),"any");
	 if (!argrslt)
	    {
	    truncflag = INITALL;
	    fldlst[MODE] = 'x';
	    i = i + 2;
	    continue;
	    } /* old */
	 fprintf(stderr,"Invalid mode %s\n",
	    *(argv+i+1));
	 putstx(*argv);
	 } /* mode */
      rslt = strcmp(*(argv+i),"-n");
      if (!rslt)
	 {
	 nodesz = atoi(*(argv+i+1));
	 fldlst[NODESZ] = 'x';
	 i = i + 2;
	 continue;
	 } /* records per node */
      rslt = strcmp(*(argv+i),"-r");
      if (!rslt)
	 {
	 rcdlen = atoi(*(argv+i+1));
	 fldlst[RCDLEN] = 'x';
	 i = i + 2;
	 continue;
	 } /* record length */
      rslt = strcmp(*(argv+i),"-k");
      if (!rslt)
	 {
	 keylen = atoi(*(argv+i+1));
	 fldlst[KEYLEN] = 'x';
	 i = i + 2;
	 continue;
	 } /* key length */
      rslt = strcmp(*(argv+i),"-o");
      if (!rslt)
	 {
	 keyofst = atoi(*(argv+i+1));
	 fldlst[KEYOFST] = 'x';
	 i = i + 2;
	 continue;
	 } /* key offset */
      rslt = strcmp(*(argv+i),"-d");
      if (!rslt)
	 {
	 dletofst = atoi(*(argv+i+1));
	 fldlst[DLETOFST] = 'x';
	 i = i + 2;
	 continue;
	 } /* delete byte offset */
      fprintf(stderr,"Invalid parameter %s\n",
	 *(argv+i));
      putstx(*argv);
      } /* for each parm */
   strcpy(dbname,*(argv+13));

   fldlst[DLM] = '\0';
   rslt = strcmp(fldlst,"xxxxxx");

   if (rslt)
      {
      fprintf(stderr,"Incomplete parameter list %s\n",
	 fldlst);
      putstx(*argv);
      } /* incomplete parmlist */

   rslt = btinit(dbname,truncflag,nodesz,
      rcdlen, keylen, keyofst, dletofst);

   return(0);
   } /* main */
